Unit DOSGUI;

{$F+}
{$O+}

 Interface

 Uses
   Crt, Dos, Strings, Graph, ms_mouse;


  Type
   LnEdData = Record
    X1,X2,Y:Integer;
    Text:PChar;
   End;

   BI = Record
    X1,X2,Y1,Y2:Integer;
    Status:Integer;
    Title:String;
    RS:Pointer;
    Size:Word;
   End;

   PBX = ^BX;
   BX = Array[1..41] Of BI;

   LEDataX = Array[0..20] Of LnEdData;

 Const
   On    =    1;
   Off   =    0;

 Var
   PName:String;
   w,t,x,y,bt,OX,OY:Word;
   B,D:PBX;
   NOPDM,N,DN:Integer;
   Hour, Minute, Second, Sec100: Word;
   PMin:Word;
   LEData:LEDataX;


 Procedure DG_Init;

{ Procedure DG_Saver;}

{ Procedure DG_MenuBar(MenuData:PMenuX; N:Integer; PrName:String);

 Procedure DG_MenuCheckPull;}

 Procedure DG_Dialog(X1,Y1,X2,Y2:Integer; Title:String);

 Procedure DG_Button(X1,Y1,X2,Y2:Integer; Title:String; O:Integer);

 Procedure DG_LineEditField(X1,X2,Y:Integer);

 Procedure DG_RestoreScreen;

 Procedure DG_Events;

 Implementation



 Procedure DG_Init;

  Var
    DR,MO,I:Integer;

  Begin
    New(B);
    New(D);
    {New(MenuD);}
    DetectGraph(DR,MO);
    InitGraph(DR,MO,'.\bgi');
    For I:=1 To 40 Do
     B^[I].Status:=0;
    {SetFillStyle(1,1);
    FloodFill(20,20,2);
    SetColor(12);
    SetTextStyle(DefaultFont,HorizDir,15);
    OutTextXY(140,50,'DOS');
    OutTextXY(140,240,'GUI');
    SetTextStyle(DefaultFont,HorizDir,1);
    SetTextJustify(CenterText,CenterText);
    OutTextXY(GetMaxX Div 2,400,'A graphical user interface by Derek Konigsberg');
    show_cursor;
    Repeat
    x:=get_x; y:=get_y;
    read_status(x,y,bt);
    Until bt=1;}
    hide_cursor;
    ClearViewPort;
    SetFillStyle(1,1);
    FloodFill(20,20,2);
    N:=0; DN:=0;
    show_cursor;
    {GetTime(Hour,Minute,Second,Sec100);
    PMin:=Minute;}
    OX:=1; OY:=1;
  End;

{ Procedure DG_Saver;

  Var
    P:Pointer;
    Size:Word;
    I,X2,Y2:Integer;
    C:LongInt;

  Begin
    GetTime(Hour,Minute,Second,Sec100);
    read_status(x,y,bt);
    If (Minute - PMin = 1) And (x = OX) And (y = OY) Then
     Begin
      read_status(x,y,bt);
      X2:=x; Y2:=y;
      hide_cursor;
      ClearDevice;
      I:=0; C:=0;
      Repeat
       Inc(C); Inc(I);
       SetColor (C);
       Rectangle (I,I,GetMaxX-I,GetMaxY-I);
       If I=640 Then I:=0;
       read_status(x,y,bt);
      Until (x <> X2) And (y <> Y2);
      PMin:=Minute;
      ClearDevice;
      DG_RestoreScreen;
     End
    Else
     Begin
      PMin:=Minute;
      OX:=x; OY:=y;
     End;
  End;}

{ Procedure DG_MenuBar(MenuData:PMenuX; N:Integer; PrName:String);

  Var
    I,J,D:Integer;

  Begin
    hide_cursor;
    SetFillStyle(1,12);
    Bar(0,0,GetMaxX,20);
    SetTextStyle(DefaultFont,HorizDir,2);
    SetTextJustify(CenterText, TopText);
    SetColor(15);
    SetFillStyle(1,7);
    Bar(0,20,GetMaxX,40);
    D:=(GetMaxX Div 2);
    OutTextXY(D,2,PrName);
    SetColor(0);
    SetTextStyle(DefaultFont,HorizDir,1);
    J:=20;
    For I := 1 To N Do
     Begin
     SetTextJustify(LeftText, CenterText);
     OutTextXY(J,32,MenuData^[I].Title);
     J:=(J+(Length(MenuData^[I].Title)*10)+10);
     End;
    MenuD^:=MenuData^;
    PName:=PrName;
    NOPDM:=N;
    show_cursor;
  End;}

 Procedure DG_Dialog(X1,Y1,X2,Y2:Integer; Title:String);

  Begin
    Inc(DN);
    hide_cursor;
    SetColor(0); Rectangle(X1,Y1,X2,Y2);
    SetFillStyle(1,0); FloodFill(X1+1,Y1+1,0);
    SetColor(7);
    Rectangle(X1,Y1,X2,Y2);
    Rectangle(X1+5,Y1+20,X2-5,Y2-5);
    SetFillStyle(1,4);
    FloodFill(X1+2,Y1+2,7);
    SetFillStyle(1,3);
    FloodFill(X1+6,Y1+21,7);
    SetColor(8); Rectangle(X1+5,Y1+2,X1+18,Y1+18);
    SetFillStyle(1,7);
    FloodFill(X1+6,Y1+6,8);
    SetColor(2);
    SetTextJustify(LeftText,TopText);
    SetTextStyle(DefaultFont,HorizDir,2);
    OutTextXY(X1+30,Y1+3,Title);
    D^[DN].X1:=X1; D^[DN].Y1:=Y1; D^[DN].X2:=X2; D^[DN].Y2:=Y2;
    D^[DN].Title:=Title;
    show_cursor;
  End;

  Procedure DG_Button(X1,Y1,X2,Y2:Integer; Title:String; O:Integer);

   Var
     bt,w,t,x,y:Word;
     C:Char;
     XX1,XX2,YY1,YY2:Integer;

   Begin
     If O = 0 Then N:=N-1
     Else
     Begin
     Inc(N);
     hide_cursor;
     SetColor(8); Line(X1,Y2,X2,Y2); Line(X2,Y1,X2,Y2);
     SetColor(15); Line(X1,Y1,X1,Y2); Line(X1,Y1,X2,Y1);
     SetColor(7); Rectangle(X1+1,Y1+1,X2-1,Y2-1);
     SetFillStyle(1,7); FloodFill(X1+4,Y1+4,7);
     SetTextStyle(DefaultFont,HorizDir,1);
     SetTextJustify(CenterText, CenterText);
     SetColor(0);
     OutTextXY(((X2-X1)Div 2)+X1,((Y2-Y1)Div 2)+Y1,Title);
     B^[N].X1:=X1; B^[N].X2:=X2; B^[N].Y1:=Y1; B^[N].Y2:=Y2;
     B^[N].Title:=Title;
     show_cursor;
     End;
   End;

 Procedure DG_LineEditField(X1,X2,Y:Integer);

  Begin
    SetFillStyle(1,15);
    Bar(X1,Y,X2,Y+20);
    SetColor(8);
    Rectangle(X1,Y,X2,Y+20);
    LEData[1].X1:=X1; LEData[1].X2:=X2; LEData[1].Y:=Y;
  End;

 Procedure DG_LineEditFieldDo;

  Var
    I,J:Integer;
    CH,C:PChar;

  Begin
    bt:=0;
    read_status(x,y,bt);
    For J:=1 To 20 Do
    Begin
    If (bt=1) And (x > LEData[J].X1) And (x < LEData[J].X2)
    And (y > LEData[J].Y) And (y < LEData[J].Y+20) Then
     Begin
      hide_cursor;
      I:=1;
      LEData[J].Text:='';
      SetFillStyle(1,15);
      Bar(LEData[J].X1,LEData[J].Y,LEData[J].X2,LEData[J].Y+20);
      SetColor(2);
      Rectangle(LEData[J].X1,LEData[J].Y,LEData[J].X2,LEData[J].Y+20);
      Repeat
       CH^:=ReadKey;
       Begin
        Case CH^ of
         Chr(13): C^:='';
         Chr(8) : If(I>1) Then
                  Begin
                   Dec(I);
                   Bar(((LEData[J].X1+4)+8*(I-1))+5,LEData[J].Y+2,LEData[J].X2-2,LEData[J].Y+18);
                  End;
        Else
         If (I<((LEData[J].X2-LEData[J].X1)Div(8))) Then
         Begin
          Inc(I);
          SetTextStyle(DefaultFont,HorizDir,1);
          SetColor(0);
          OutTextXY((LEData[J].X1+4)+8*(I-1),LEData[J].Y+12,CH^);
          StrCat(LEData[J].Text,CH);
         End;
       End;
       End;
      Until (C^ ='');
      SetColor(8);
      Rectangle(LEData[J].X1,LEData[J].Y,LEData[J].X2,LEData[J].Y+20);
      show_cursor;
     End;
    End;
  End;



 Procedure DG_RestoreScreen;

  Var
    I,DR,MO:Integer;

  Begin
    hide_cursor;
    ClearDevice;
    SetFillStyle(1,1);
    FloodFill(10,10,14);
    For I:=DN To DN Do
     Begin
     If (D^[I].X1 <> 0) And (D^[I].X2 <> 0) Then
     Begin
     hide_cursor;
     SetColor(0); Rectangle(D^[I].X1,D^[I].Y1,D^[I].X2,D^[I].Y2);
     SetFillStyle(1,0); FloodFill(D^[I].X1+1,D^[I].Y1+1,0);
     SetColor(7);
     Rectangle(D^[I].X1,D^[I].Y1,D^[I].X2,D^[I].Y2);
     Rectangle(D^[I].X1+5,D^[I].Y1+20,D^[I].X2-5,D^[I].Y2-5);
     SetFillStyle(1,4);
     FloodFill(D^[I].X1+2,D^[I].Y1+2,7);
     SetFillStyle(1,3);
     FloodFill(D^[I].X1+6,D^[I].Y1+21,7);
     SetColor(8); Rectangle(D^[I].X1+5,D^[I].Y1+2,D^[I].X1+18,D^[I].Y1+18);
     SetFillStyle(1,7);
     FloodFill(D^[I].X1+6,D^[I].Y1+6,8);
     SetColor(2);
     SetTextJustify(LeftText,TopText);
     SetTextStyle(DefaultFont,HorizDir,2);
     OutTextXY(D^[I].X1+30,D^[I].Y1+3,D^[I].Title);
     show_cursor;
     End;
     End;
     For I:=1 To N Do
     Begin
      If (B^[I].X1 <> 0) And (B^[I].X2 <> 0) Then
      Begin
      hide_cursor;
      SetColor(8); Line(B^[I].X1,B^[I].Y2,B^[I].X2,B^[I].Y2); Line(B^[I].X2,B^[I].Y1,B^[I].X2,B^[I].Y2);
      SetColor(15); Line(B^[I].X1,B^[I].Y1,B^[I].X1,B^[I].Y2); Line(B^[I].X1,B^[I].Y1,B^[I].X2,B^[I].Y1);
      SetColor(7); Rectangle(B^[I].X1+1,B^[I].Y1+1,B^[I].X2-1,B^[I].Y2-1);
      SetFillStyle(1,7); FloodFill(B^[I].X1+4,B^[I].Y1+4,7);
      SetTextStyle(DefaultFont,HorizDir,1);
      SetTextJustify(CenterText, CenterText);
      SetColor(0);
      OutTextXY(((B^[I].X2-B^[I].X1)Div 2)+B^[I].X1,((B^[I].Y2-B^[I].Y1)Div 2)+B^[I].Y1,B^[I].Title);
      show_cursor;
      End;
     End;
     show_cursor;
  End;

 Procedure DG_Events;

   Var
     I:Integer;
     C:Char;

   Begin
     For I:=1 To N Do
     Begin
     x:=0; y:=0; bt:=0;
     read_status(x,y,bt);
     If (bt = 1) And (x > B^[I].X1) And (x < B^[I].X2) And (y > B^[I].Y1) And (y < B^[I].Y2) Then
      Begin
      hide_cursor;
{      SetColor(0); Line(B^[I].X1,B^[I].Y1,B^[I].X1,B^[I].Y2); Line(B^[I].X1,B^[I].Y1,B^[I].X2,B^[I].Y1);
      Line(B^[I].X1+1,B^[I].Y2-1,B^[I].X2-1,B^[I].Y2-1); Line(B^[I].X2-1,B^[I].Y1+1,B^[I].X2-1,B^[I].Y2-1);
      Line(B^[I].X1+1,B^[I].Y1+1,B^[I].X1+1,B^[I].Y2-1); Line(B^[I].X1+1,B^[I].Y1+1,B^[I].X2-2,B^[I].Y1+1);
      SetColor(0); Line(B^[I].X1,B^[I].Y2,B^[I].X2,B^[I].Y2); Line(B^[I].X2,B^[I].Y1,B^[I].X2,B^[I].Y2);
}
      SetColor(7); Rectangle(B^[I].X1+1,B^[I].Y1+1,B^[I].X2-1,B^[I].Y2-1);
      SetColor(15); Line(B^[I].X1,B^[I].Y2,B^[I].X2,B^[I].Y2); Line(B^[I].X2,B^[I].Y1,B^[I].X2,B^[I].Y2);
      SetColor(8); Line(B^[I].X1,B^[I].Y1,B^[I].X1,B^[I].Y2); Line(B^[I].X1,B^[I].Y1,B^[I].X2,B^[I].Y1);
      Case B^[I].Status Of
       1:B^[I].Status:=0;
       0:B^[I].Status:=1;
      End;
      show_cursor;
      bt:=0;
      Repeat
      read_status(x,y,bt);
      Until bt <> 1;
     hide_cursor;
     SetColor(7); Rectangle(B^[I].X1+1,B^[I].Y1+1,B^[I].X2-1,B^[I].Y2-1);
     SetColor(8); Line(B^[I].X1,B^[I].Y2,B^[I].X2,B^[I].Y2); Line(B^[I].X2,B^[I].Y1,B^[I].X2,B^[I].Y2);
     SetColor(15); Line(B^[I].X1,B^[I].Y1,B^[I].X1,B^[I].Y2); Line(B^[I].X1,B^[I].Y1,B^[I].X2,B^[I].Y1);
     show_cursor;
     End;
    End;
    For I:=1 To DN Do
    Begin
    x:=0; y:=0; bt:=0;
    read_status(x,y,bt);
    If (bt = 1) And (x > D^[I].X1+5) And (x < D^[I].X1+18) And (y > D^[I].Y1+2) And (y < D^[I].Y1+18) Then
    Begin
    hide_cursor;
    SetFillStyle(1,8);
    FloodFill(D^[I].X1+6,D^[I].Y1+6,8);
    SetColor(7); Rectangle(D^[I].X1,D^[I].Y1,D^[I].X2,D^[I].Y2);
    show_cursor;
    bt:=0;
    Repeat
    read_status(x,y,bt);
    Until bt <> 1;
    hide_cursor;
    SetColor(1); SetFillStyle(1,1);
    Rectangle(D^[I].X1,D^[I].Y1,D^[I].X2,D^[I].Y2);
    FloodFill(D^[I].X1+2,D^[I].Y1+2,1);
    D^[I].X1:=0; D^[I].Y1:=0; D^[I].X2:=0; D^[I].Y2:=0;
    DG_RestoreScreen;
    show_cursor;
    End;
   End;
   DG_LineEditFieldDo;
   End;
End.


 

