Unit SOMenus;


interface

Uses
  Crt,Dos;

Var
  MENU:String;

Procedure WriteXY(X,Y:Integer; S:String);

Procedure hidecursor;

Procedure restorecursor;

Procedure Main_Menu;

Procedure Menu_1;

Function IntToStr(i: Longint): String;




IMPLEMENTATION

 Procedure WriteXY(X,Y:Integer; S:String);
  Begin
   GotoXY(X,Y);
   Write(S);
  End;

procedure hidecursor ;
var regpack : registers ;  (* register list for interrupt call *)
begin
   with regpack do            (* set up for interrupt *)
      begin
         ax := $0100 ;        (* function 1 = set cursor type      *)
         cx := $1000 ;        (* CH = start line and CL = end line *)
      end;
   intr ($10,regpack) ;       (* call video interrupt routine *)
end ;   (* hidecursor *)

procedure restorecursor ;
var regpack : registers ;  (* register list for interrupt call *)
begin
   with regpack do            (* set up for interrupt *)
      begin
         ax := $0100 ;        (* function 1 = set cursor type      *)
         cx := $0007 ;        (* CH = start line and CL = end line *)
      end;
   intr ($10,regpack) ;       (* call video interrupt routine *)
end ;   (* restorecursor *)

function IntToStr(i: Longint): string;
{ Convert any Integer type to a string }
var
  s: string[11];
begin
  Str(i, s);
  IntToStr := s;
end;


 Procedure Menu_1;

  Var
    I,J,M:Integer;
    CH:Char;
 

  Begin

    ClrScr;
    TextColor(Blue);
    For I:=1 To 26 Do
     Begin
      For J:=1 To 80 Do
       Write('');
     End;
    hidecursor;
    TextColor(Blue); TextBackground(7);
    WriteXY(22,06,'Ŀ');
    WriteXY(22,07,'          Pick a layout           ');
    WriteXY(22,08,'Ĵ');
    WriteXY(22,09,'                                  ');
    WriteXY(22,10,'                                  ');
    WriteXY(22,11,'                                  ');
    WriteXY(22,12,'                                  ');
    WriteXY(22,13,'                                  ');
    WriteXY(22,14,'                                  ');
    WriteXY(22,15,'                                  ');
    WriteXY(22,16,'                                  ');
    WriteXY(22,17,'                                  ');
    WriteXY(22,18,'');
    TextColor(1);
    WriteXY(25,10,'1  Checklist');
    WriteXY(25,11,'2  Daily schedule');
    WriteXY(25,12,'3  Weekly schedule');
    WriteXY(25,13,'4  Quit to main menu');
    M:=0;
    CH:=' ';
    While CH <> '' Do
    Begin
    CH:=ReadKey;
    TextBackground(7);
     Case M Of
      1:WriteXY(25,10,'1  Checklist');
      2:WriteXY(25,11,'2  Daily schedule');
      3:WriteXY(25,12,'3  Weekly schedule');
      4:WriteXY(25,13,'4  Quit to main menu');
     End;
     Case CH Of
          '8':M:=M-1;
          '2':M:=M+1;
      Chr(13):CH:='';

     End;
     Case M Of
      0:M:=4;
      5:M:=1;
     End;
     TextBackground(2);
     Case M Of
      1:WriteXY(25,10,'1  Checklist');
      2:WriteXY(25,11,'2  Daily schedule');
      3:WriteXY(25,12,'3  Weekly schedule');
      4:WriteXY(25,13,'4  Quit to main menu');
     End;
    
    End;
    MENU:=IntToStr(M);
  End;

  Procedure Main_Menu;

  Var
    I,J,M:Integer;
    CH:Char;
 

  Begin

    ClrScr;
    TextColor(Blue);
    For I:=1 To 26 Do
     Begin
      For J:=1 To 80 Do
       Write('');
     End;
    hidecursor;
    TextColor(Blue); TextBackground(7);
    WriteXY(22,06,'Ŀ');
    WriteXY(22,07,'                                  ');
    WriteXY(22,08,'                                  ');
    WriteXY(22,09,'                                  ');
    WriteXY(22,10,'                                  ');
    WriteXY(22,11,'                                  ');
    WriteXY(22,12,'                                  ');
    WriteXY(22,13,'                                  ');
    WriteXY(22,14,'                                  ');
    WriteXY(22,15,'                                  ');
    WriteXY(22,16,'                                  ');
    WriteXY(22,17,'                                  ');
    WriteXY(22,18,'');
    TextColor(1);
    WriteXY(25,08,'1  Start new schedule');
    WriteXY(25,09,'2  Load old schedule');
    WriteXY(25,10,'3  Print a schedule');
    WriteXY(25,11,'4  Quit');
    M:=0;
    CH:=' ';
    While CH <> '' Do
    Begin
    CH:=ReadKey;
    TextBackground(7);
     Case M Of
      1:WriteXY(25,08,'1  Start new schedule');
      2:WriteXY(25,09,'2  Load old schedule');
      3:WriteXY(25,10,'3  Print a schedule');
      4:WriteXY(25,11,'4  Quit');
     End;
     Case CH Of
          '8':M:=M-1;
          '2':M:=M+1;
      Chr(13):CH:='';
     End;
     Case M Of
      0:M:=4;
      5:M:=1;
     End;
     TextBackground(2);
     Case M Of
      1:WriteXY(25,08,'1  Start new schedule');
      2:WriteXY(25,09,'2  Load old schedule');
      3:WriteXY(25,10,'3  Print a schedule');
      4:WriteXY(25,11,'4  Quit');
     End;
    End;
   MENU:=IntToStr(M);
  End;
End.
